<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { onUpdated, ref, onMounted, onBeforeUnmount, computed } from 'vue';
import { Dialog, DialogPanel } from '@headlessui/vue';
import Button from '@/components/general/Button.vue';
//import Tooltip from '@/components/general/Tooltip.vue';

const props = defineProps<{
    modelValue?: Boolean,
    header?: string,
    text?: string,
    labelSubmit?: string,
    labelCancel?: string,
    afterSubmitClose?: boolean,
    labelLeft?: string,
    iconLeft?: string,
    tooltipLeft?: string,
    iconLeftColor?: string,
    disableSubmit?: boolean,
    font?: string
}>();

//export const modal = ref(null);

const emits = defineEmits<{
    //(e: "update:modelValue", value:boolean):void,
    (e: "submit"): void,
    (e: "cancel"): void,
    (e: "close", value: boolean): void,
    (e: "left"): void
}>();

const isOpen = ref(false);

/*onUpdated(()=>{
    if(props.modelValue){
        isOpen.value = true;
    }
    else{
        isOpen.value = false;
    }
});*/

onMounted(() => {
    isOpen.value = true;
})

onBeforeUnmount(() => {
    isOpen.value = false;
})

const submitModal = () => {
    if (props.afterSubmitClose == undefined || props.afterSubmitClose == true)
        emits('close', false);
    emits('submit');

}

const closeModal = () => {
    emits('close', false);
    emits('cancel');
}

const leftModal = () => {
    emits('close', false);
    emits('left');

}

const leftButtonClass = computed(() => {
    return props.iconLeftColor + " text-2xl";
});

</script>
<template>
    <Dialog :open="isOpen" class="relative z-[9998]" as="div">
        <div aria-hidden="true" class="fixed inset-0 bg-black/50"></div>
        <div class="fixed inset-0 flex justify-center">
            <DialogPanel as="div"
                class="relative ml-auto mr-auto mb-auto top-12 w-[600px] max-w-full rounded-xl bg-white max-h-[calc(100dvh-6em)]"
                :class="[font ? font : '']">
                <div class="p-8">
                    <h2 class="text-2xl select-none" v-if="header" v-html="header"></h2>
                    <p v-if="text && text.length > 0" v-html="text"></p>
                    <div class="max-h-[calc(100dvh-19em)] overflow-auto">
                        <slot></slot>
                    </div>
                </div>
                <div class="px-6 py-4 flex bg-gray-100 rounded-b-xl" v-if="labelCancel || labelSubmit || labelLeft">
                    <div class="" v-if="iconLeft || labelLeft">
                        <Button variant="default" @click="leftModal" v-if="labelLeft && !iconLeft">{{ labelLeft
                            }}</Button>
                        <Tooltip :tooltip="tooltipLeft" v-if="iconLeft"><Button variant="none"
                                :extraClass="leftButtonClass" @click="leftModal">
                                <slot name="iconLeft"></slot>
                            </Button></Tooltip>
                    </div>
                    <div class="flex flex-row gap-2 ml-auto">
                        <div class="w-full" v-if="labelCancel"><Button variant="cancel" @click="closeModal">{{ labelCancel }}</Button></div>
                        <div class="w-full" v-if="labelSubmit"><Button :variant="!disableSubmit ? 'confirm' : 'disabled'" @click="submitModal">{{ labelSubmit }}</Button></div>
                    </div>
                </div>
            </DialogPanel>
        </div>
    </Dialog>
</template>